#ifdef GL_ES
precision mediump float;
#endif

uniform sampler2D u_texture;

varying vec4 v_color;
varying vec2 v_texCoord;

const float width = .48;
const float edge = .03;

void main() {
    float distance = 1.0 - texture2D(u_texture, v_texCoord).a;
    float alpha = 1.0 - smoothstep(width, width + edge, distance);

    gl_FragColor = vec4(v_color.rgb, v_color.a * alpha);
}
