#ifdef GL_ES
precision mediump float;
#endif
varying vec2 texCoord;
uniform float u_time;
uniform vec2 u_resolution;
uniform sampler2D u_texture;
varying vec4 color;

void main() {
    vec2 coord = texCoord;

    // Generate noisy x value
    float t = u_time / 2.;
    /*if (t > 1.0)
        t -= floor(t);*/

    vec2 n0Uv = vec2(coord.x * 1.4 + 0.01, coord.y + t * 0.69);
    vec2 n1Uv = vec2(coord.x * 0.5 - 0.033, coord.y * 2.0 + t * 0.12);
    vec2 n2Uv = vec2(coord.x * 0.94 + 0.02, coord.y * 3.0 + t  * 0.61);
    float n0 = (texture2D(u_texture, n0Uv).w - 0.5) * 2.0;
    float n1 = (texture2D(u_texture, n1Uv).w - 0.5) * 2.0;
    float n2 = (texture2D(u_texture, n2Uv).w - 0.5) * 2.0;
    float noiseA = clamp(n0 + n1 + n2, -1.0, 1.0);
    // Generate noisy y value
    vec2 n0UvB = vec2(coord.x * 0.7 - 0.01, coord.y + t * 0.27);
    vec2 n1UvB = vec2(coord.x * 0.45 + 0.033, coord.y * 1.9 + t * 0.61);
    vec2 n2UvB = vec2(coord.x * 0.8 - 0.02, coord.y * 2.5 + t * 0.51);
    float n0B = (texture2D(u_texture, n0UvB).w - 0.5) * 2.0;
    float n1B = (texture2D(u_texture, n1UvB).w - 0.5) * 2.0;
    float n2B = (texture2D(u_texture, n2UvB).w - 0.5) * 2.0;
    float noiseB = clamp(n0B + n1B + n2B, -1.0, 1.0);

    vec2 finalNoise = vec2(noiseA, noiseB);
    float perturb = (1.0 - coord.y) * 0.35 + 0.02;
    finalNoise = (finalNoise * perturb) + coord - 0.02;

    vec4 color = texture2D(u_texture, finalNoise);
    color = vec4(color.x * 2.0, color.y * 0.9, (color.y / color.x) * 0.2, 1.0);
    finalNoise = clamp(finalNoise, 0.05, 1.0);
    color.w = texture2D(u_texture, finalNoise).z * 2.0;
    color.w = color.w * texture2D(u_texture, coord).z;
    gl_FragColor = color;
}
