#ifdef GL_ES
precision mediump float;
#endif
uniform sampler2D u_texture;
varying vec2 v_texCoord;
uniform float radius;

vec4 circle(vec2 position, vec2 pCord, float radius, vec4 color) {
    float cDistance = distance(position, pCord);
    return vec4(smoothstep(radius, radius - 0.2, cDistance-0.1 )) * color;
}

void main()
{
    // 0.5 x 0.5 - center texture
    vec4 outColor = circle(vec2(0.5, 0.5), v_texCoord, radius, vec4(0.0, 0.0, 0.0, 0.75));
    outColor.g = 0.85;

    vec4 color = texture2D(u_texture, v_texCoord);
    if (texture2D(u_texture, v_texCoord).a != 1.0)
    gl_FragColor = outColor;
    else
    gl_FragColor = color;
}