attribute vec3 a_position;
attribute vec3 a_normal;
attribute vec2 a_texCoord0;
attribute vec2 a_texCoord;
uniform mat4 u_projViewTrans;
varying vec2 texCoord;
varying vec2 v_texCoord0;
attribute vec2 rotate;
attribute vec3 i_offset;

mat4 rotationX(float angle)
{
    return mat4(1.0, 0.0, 0.0, 0.0,
    0.0, cos(angle), -sin(angle), 0.0,
    0.0, sin(angle), cos(angle), 0.0,
    0.0, 0.0, 0.0, 1.0);
}

mat3 rotateY(float rad)
{
    float c = cos(rad);
    float s = sin(rad);
    return mat3(c, 0.0, -s, 0.0, 1.0, 0.0, s, 0.0, c);
}

void main() {
    texCoord = a_texCoord;
    mat4 res = mat4(rotateY(rotate.y));
    vec4 view = vec4(a_position, 1.0) * res;
    vec4 trn = (view + vec4(i_offset, 1.0));
    trn.z *= rotate.x;
    gl_Position = u_projViewTrans * trn;
}