#ifdef GL_ES
precision mediump float;
#endif
varying vec2 texCoord;
uniform float u_time;
vec4 colorA = vec4(1.0, 1.0, 1.0, 1.0);
vec4 colorB = vec4(1.0, 1.0, 1.0, -1.0);
#define PI 3.14159265359

float plot(vec2 st, float pct){
    return smoothstep(pct-0.02, pct, st.y + 0.01) -
    smoothstep(pct, pct+0.02, st.y - 0.01);
}
float parabola(float value, float x, float k) {
    return pow(value*x*(1.0-x), k);
}
float circle(vec2 _st, float _radius){
    vec2 dist = _st-vec2(0.5, 0.5);
    return 1.0 -smoothstep(_radius-(_radius*0.01),
    _radius+(_radius*0.01),
    dot(dist, dist)*4.0);
}

void main() {
    float alpha = 0.0;
    vec2 st = texCoord;
    vec3 color = vec3(1.0, 1.0, 1.0);
    vec3 t = vec3(circle(st, 0.007));
    if (st.x > 0.0 && st.x < 0.3 && st.y > 0.95)
    alpha = 1.0;
    if (st.x <= 0.05 && st.y > 0.0 && st.y < 0.2 || st.x <= 0.05 && st.y > 0.8 && st.y < 1.0)
        alpha = 1.0;
    if (st.x > 0.0 && st.x < 0.3 && st.y <= 0.05)
        alpha = 1.0;
    if (st.x > 0.7 && st.x < 1.0 && st.y > 0.95)
        alpha = 1.0;
    if (st.x > 0.95 && st.y > 0.0 && st.y < 0.2 || st.x > 0.95 && st.y > 0.8 && st.y < 1.0)
        alpha = 1.0;
    if (st.x > 0.7 && st.x < 1.0 && st.y < 0.05)
        alpha = 1.0;
    if (st.x > 0.18 && st.x < 0.83)
    {
        st -= vec2(0.5);
        float ang = u_time * 5.0;
        float c = cos(ang);
        float s = sin(ang);
        mat2 trans = mat2(c, -s, s, c);// изменить направление сменить знак
        st*=trans;
        st += vec2(0.5);

        float y = parabola(1.5, st.x, 0.7);
        float y2 = parabola(-1.5, st.x, 1.0);
        if (y2 > 0.0)
            y2*=-1.0;
        float pct = plot(st, y + 0.3);
        float pct2 = plot(st, y2 + 0.6);
        if (pct > 0.9 || pct2 > 0.9)
        {
            gl_FragColor = mix(colorB, colorA, smoothstep(st.x, st.x - 0.4, 0.05)) *
            mix(colorB, colorA, smoothstep(1.0 - st.x, 1.0 - st.x - 0.4, 0.05));
            alpha = 1.0;
            return;
        }
        else if (t.x > 0.0)
        {
            color+=t;
            alpha = 1.0;
        }
        else
            alpha = 0.0;
    }
    gl_FragColor = vec4(color, alpha);
}